/*************************************************************************
 *
 *  $RCSfile: offmgr_fltrcfg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 10:56:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
// auto strip #include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _SVX_SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#include "fltrcfg.hxx"
// auto strip #include "resid.hxx"
// auto strip #ifndef _COM_SUN_STAR_UNO_ANY_HXX_
// auto strip #include <com/sun/star/uno/Any.hxx>
// auto strip #endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
namespace binfilter {

using namespace utl;
using namespace rtl;
using namespace ::com::sun::star::uno;
#define C2U(cChar) OUString::createFromAscii(cChar)

// -----------------------------------------------------------------------
#define FILTERCFG_WORD_CODE 			0x0001
#define FILTERCFG_WORD_STORAGE 			0x0002
#define FILTERCFG_EXCEL_CODE 			0x0004
#define FILTERCFG_EXCEL_STORAGE 		0x0008
#define FILTERCFG_PPOINT_CODE 			0x0010
#define FILTERCFG_PPOINT_STORAGE 		0x0020
#define FILTERCFG_MATH_LOAD				0x0100
#define FILTERCFG_MATH_SAVE				0x0200
#define FILTERCFG_WRITER_LOAD			0x0400
#define FILTERCFG_WRITER_SAVE			0x0800
#define FILTERCFG_CALC_LOAD				0x1000
#define FILTERCFG_CALC_SAVE				0x2000
#define FILTERCFG_IMPRESS_LOAD			0x4000
#define FILTERCFG_IMPRESS_SAVE			0x8000


/* -----------------------------22.01.01 10:23--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ class OfaAppFilterOptions_Impl : public ::utl::ConfigItem
/*N*/ {
/*N*/ 	sal_Bool				bLoadVBA;
/*N*/ 	sal_Bool				bSaveVBA;
/*N*/ public:
/*N*/ 	OfaAppFilterOptions_Impl(const OUString& rRoot) :
/*N*/ 		::utl::ConfigItem(rRoot),
/*N*/ 		bLoadVBA(sal_False),
/*N*/ 		bSaveVBA(sal_False)	 {}
/*N*/ 	~OfaAppFilterOptions_Impl();
//STRIP001 	virtual void			::com::mit();
/*N*/ 	void					Load();
/*N*/ 
/*N*/ 	sal_Bool				IsLoad() const {return bLoadVBA;}
/*N*/ 	void					SetLoad(sal_Bool bSet)
/*N*/ 							{
/*N*/ 								if(bSet != bLoadVBA)
/*N*/ 									SetModified();
/*N*/ 								bLoadVBA = bSet;
/*N*/ 							}
/*N*/ 	sal_Bool				IsSave() const {return bSaveVBA;}
/*N*/ 	void					SetSave(sal_Bool bSet)
/*N*/ 							{
/*N*/ 								if(bSet != bSaveVBA)
/*N*/ 									SetModified();
/*N*/ 								bSaveVBA = bSet;
/*N*/ 							}
/*N*/ };
/* -----------------------------22.01.01 11:08--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ OfaAppFilterOptions_Impl::~OfaAppFilterOptions_Impl()
/*N*/ {
/*N*/ 	if(IsModified())
/*?*/ 		Commit();
/*N*/ }
/* -----------------------------22.01.01 10:38--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 void	OfaAppFilterOptions_Impl::Commit()
//STRIP001 {
//STRIP001 	Sequence<OUString> aNames(2);
//STRIP001 	OUString* pNames = aNames.getArray();
//STRIP001 	pNames[0] = C2U("Load");
//STRIP001 	pNames[1] = C2U("Save");
//STRIP001 	Sequence<Any> aValues(aNames.getLength());
//STRIP001 	Any* pValues = aValues.getArray();
//STRIP001 
//STRIP001 	const Type& rType = ::getBooleanCppuType();
//STRIP001 	pValues[0].setValue(&bLoadVBA, rType);
//STRIP001 	pValues[1].setValue(&bSaveVBA, rType);
//STRIP001 
//STRIP001 	PutProperties(aNames, aValues);
//STRIP001 }
/* -----------------------------22.01.01 10:38--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ void	OfaAppFilterOptions_Impl::Load()
/*N*/ {
/*N*/ 	Sequence<OUString> aNames(2);
/*N*/ 	OUString* pNames = aNames.getArray();
/*N*/ 	pNames[0] = C2U("Load");
/*N*/ 	pNames[1] = C2U("Save");
/*N*/ 
/*N*/ 	Sequence<Any> aValues = GetProperties(aNames);
/*N*/ 	const Any* pValues = aValues.getConstArray();
/*N*/ 
/*N*/ 	const Type& rType = ::getBooleanCppuType();
/*N*/ 	if(pValues[0].hasValue())
/*N*/ 		bLoadVBA = *(sal_Bool*)pValues[0].getValue();
/*N*/ 	if(pValues[1].hasValue())
/*N*/ 		bSaveVBA = *(sal_Bool*)pValues[1].getValue();
/*N*/ }
/* -----------------------------22.01.01 10:32--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ struct OfaFilterOptions_Impl
/*N*/ {
/*N*/ 	ULONG nFlags;
/*N*/ 	OfaAppFilterOptions_Impl	aWriterCfg;
/*N*/ 	OfaAppFilterOptions_Impl	aCalcCfg;
/*N*/ 	OfaAppFilterOptions_Impl	aImpressCfg;
/*N*/ 
/*N*/ 	OfaFilterOptions_Impl() :
/*N*/ 		aWriterCfg(C2U("Office.Writer/Filter/Import/VBA")),
/*N*/ 		aCalcCfg(C2U("Office.Calc/Filter/Import/VBA")),
/*N*/ 		aImpressCfg(C2U("Office.Impress/Filter/Import/VBA"))
/*N*/ 		{
/*N*/ 			nFlags = FILTERCFG_WORD_CODE		| FILTERCFG_WORD_STORAGE |
/*N*/ 					FILTERCFG_EXCEL_CODE	| FILTERCFG_EXCEL_STORAGE |
/*N*/ 					FILTERCFG_PPOINT_CODE	| FILTERCFG_PPOINT_STORAGE |
/*N*/ 					FILTERCFG_MATH_LOAD		| FILTERCFG_MATH_SAVE |
/*N*/ 					FILTERCFG_WRITER_LOAD	| FILTERCFG_WRITER_SAVE |
/*N*/ 					FILTERCFG_CALC_LOAD		| FILTERCFG_CALC_SAVE	|
/*N*/ 					FILTERCFG_IMPRESS_LOAD	| FILTERCFG_IMPRESS_SAVE;
/*N*/ 		   Load();
/*N*/ 		}
/*N*/ 
/*N*/ 	void SetFlag( ULONG nFlag, BOOL bSet );
/*N*/ 	BOOL IsFlag( ULONG nFlag ) const;
/*N*/ 	void	Load()
/*N*/ 	{
/*N*/ 		aWriterCfg.Load();
/*N*/ 		aCalcCfg.Load();
/*N*/ 		aImpressCfg.Load();
/*N*/ 	}
/*N*/ };
/* -----------------------------22.01.01 10:34--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ void OfaFilterOptions_Impl::SetFlag( ULONG nFlag, BOOL bSet )
/*N*/ {
/*N*/ 	switch(nFlag)
/*N*/ 	{
/*?*/ 		case FILTERCFG_WORD_CODE:		aWriterCfg.SetLoad(bSet);break;
/*?*/ 		case FILTERCFG_WORD_STORAGE:	aWriterCfg.SetSave(bSet);break;
/*?*/ 		case FILTERCFG_EXCEL_CODE:		aCalcCfg.SetLoad(bSet);break;
/*?*/ 		case FILTERCFG_EXCEL_STORAGE:	aCalcCfg.SetSave(bSet);break;
/*?*/ 		case FILTERCFG_PPOINT_CODE:		aImpressCfg.SetLoad(bSet);break;
/*?*/ 		case FILTERCFG_PPOINT_STORAGE:	aImpressCfg.SetSave(bSet);break;
/*N*/ 		default:
/*N*/ 			if( bSet )
/*N*/ 				nFlags |= nFlag;
/*N*/ 			else
/*N*/ 				nFlags &= ~nFlag;
/*N*/ 	}
/*N*/ }
/* -----------------------------22.01.01 10:35--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ BOOL OfaFilterOptions_Impl::IsFlag( ULONG nFlag ) const
/*N*/ {
/*N*/ 	BOOL bRet;
/*N*/ 	switch(nFlag)
/*N*/ 	{
/*?*/ 		case FILTERCFG_WORD_CODE 		: bRet = aWriterCfg.IsLoad();break;
/*?*/ 		case FILTERCFG_WORD_STORAGE   	: bRet = aWriterCfg.IsSave();break;
/*?*/ 		case FILTERCFG_EXCEL_CODE 	    : bRet = aCalcCfg.IsLoad();break;
/*N*/ 		case FILTERCFG_EXCEL_STORAGE    : bRet = aCalcCfg.IsSave();break;
/*?*/ 		case FILTERCFG_PPOINT_CODE 	 	: bRet = aImpressCfg.IsLoad();break;
/*N*/ 		case FILTERCFG_PPOINT_STORAGE	: bRet = aImpressCfg.IsSave();break;
/*N*/ 		default:
/*?*/ 			bRet = 0 != (nFlags & nFlag );
/*N*/ 	}
/*N*/ 	return bRet;
/*N*/ }

// -----------------------------------------------------------------------

/*N*/ OfaFilterOptions::OfaFilterOptions() :
/*N*/ 	ConfigItem( C2U("Office.Common/Filter/Microsoft") ),
/*N*/ 	pImp(new OfaFilterOptions_Impl)
/*N*/ {
/*N*/ 	EnableNotification(GetPropertyNames());
/*N*/ 	Load();
/*N*/ }
// -----------------------------------------------------------------------
/*N*/ OfaFilterOptions::~OfaFilterOptions()
/*N*/ {
/*N*/ 	delete pImp;
/*N*/ }
/* -----------------------------22.01.01 08:45--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ const Sequence<OUString>& OfaFilterOptions::GetPropertyNames()
/*N*/ {
/*N*/ 	static Sequence<OUString> aNames;
/*N*/ 	if(!aNames.getLength())
/*N*/ 	{
/*N*/ 		int nCount = 8;
/*N*/ 		aNames.realloc(nCount);
/*N*/ 		static const char* aPropNames[] =
/*N*/ 		{
/*N*/ 			"Import/MathTypeToMath",			//  0
/*N*/ 			"Import/WinWordToWriter",			//  1
/*N*/ 			"Import/PowerPointToImpress",		//  2
/*N*/ 			"Import/ExcelToCalc",				//  3
/*N*/ 			"Export/MathToMathType",            //  4
/*N*/ 			"Export/WriterToWinWord",           //  5
/*N*/ 			"Export/ImpressToPowerPoint",       //  6
/*N*/ 			"Export/CalcToExcel"            	//  7
/*N*/ 		};
/*N*/ 		OUString* pNames = aNames.getArray();
/*N*/ 		for(int i = 0; i < nCount; i++)
/*N*/ 			pNames[i] = C2U(aPropNames[i]);
/*N*/ 	}
/*N*/ 	return aNames;
/*N*/ }
//-----------------------------------------------------------------------
/*N*/ ULONG lcl_GetFlag(sal_Int32 nProp)
/*N*/ {
/*N*/ 	ULONG nFlag = 0;
/*N*/ 	switch(nProp)
/*N*/ 	{
/*N*/ 		case  0: nFlag = FILTERCFG_MATH_LOAD; break;
/*N*/ 		case  1: nFlag = FILTERCFG_WRITER_LOAD; break;
/*N*/ 		case  2: nFlag = FILTERCFG_IMPRESS_LOAD; break;
/*N*/ 		case  3: nFlag = FILTERCFG_CALC_LOAD; break;
/*N*/ 		case  4: nFlag = FILTERCFG_MATH_SAVE; break;
/*N*/ 		case  5: nFlag = FILTERCFG_WRITER_SAVE; break;
/*N*/ 		case  6: nFlag = FILTERCFG_IMPRESS_SAVE; break;
/*N*/ 		case  7: nFlag = FILTERCFG_CALC_SAVE; break;
/*N*/ 		default: DBG_ERROR("illegal value");
/*N*/ 	}
/*N*/ 	return nFlag;
/*N*/ }
/*-- 22.01.01 08:53:03---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 void OfaFilterOptions::Notify( const Sequence<OUString>& aPropertyNames)
//STRIP001 {
//STRIP001 	Load();
//STRIP001 }
/*-- 22.01.01 08:53:04---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 void OfaFilterOptions::Commit()
//STRIP001 {
//STRIP001 	const Sequence<OUString>& aNames = GetPropertyNames();
//STRIP001 	const OUString* pNames = aNames.getConstArray();
//STRIP001 	Sequence<Any> aValues(aNames.getLength());
//STRIP001 	Any* pValues = aValues.getArray();
//STRIP001 
//STRIP001 	const Type& rType = ::getBooleanCppuType();
//STRIP001 	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
//STRIP001 	{
//STRIP001 		ULONG nFlag = lcl_GetFlag(nProp);
//STRIP001 		sal_Bool bVal = pImp->IsFlag( nFlag);
//STRIP001 		pValues[nProp].setValue(&bVal, rType);
//STRIP001 
//STRIP001 	}
//STRIP001 	PutProperties(aNames, aValues);
//STRIP001 }
/*-- 22.01.01 08:53:04---------------------------------------------------

  -----------------------------------------------------------------------*/
/*N*/ void OfaFilterOptions::Load()
/*N*/ {
/*N*/ 	pImp->Load();
/*N*/ 	const Sequence<OUString>& rNames = GetPropertyNames();
/*N*/ 	Sequence<Any> aValues = GetProperties(rNames);
/*N*/ 	const Any* pValues = aValues.getConstArray();
/*N*/ 	DBG_ASSERT(aValues.getLength() == rNames.getLength(), "GetProperties failed")
/*N*/ 	if(aValues.getLength() == rNames.getLength())
/*N*/ 	{
/*N*/ 		for(int nProp = 0; nProp < rNames.getLength(); nProp++)
/*N*/ 		{
/*N*/ 			if(pValues[nProp].hasValue())
/*N*/ 			{
/*N*/ 				sal_Bool bVal = *(sal_Bool*)pValues[nProp].getValue();
/*N*/ 				ULONG nFlag = lcl_GetFlag(nProp);
/*N*/ 				pImp->SetFlag( nFlag, bVal);
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ }
// -----------------------------------------------------------------------

//STRIP001 void OfaFilterOptions::SetLoadWordBasicCode( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_WORD_CODE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsLoadWordBasicCode() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_WORD_CODE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetLoadWordBasicStorage( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_WORD_STORAGE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsLoadWordBasicStorage() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_WORD_STORAGE );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void OfaFilterOptions::SetLoadExcelBasicCode( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_EXCEL_CODE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsLoadExcelBasicCode() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_EXCEL_CODE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetLoadExcelBasicStorage( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_EXCEL_STORAGE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

/*N*/ BOOL OfaFilterOptions::IsLoadExcelBasicStorage() const
/*N*/ {
/*N*/ 	return pImp->IsFlag( FILTERCFG_EXCEL_STORAGE );
/*N*/ }

// -----------------------------------------------------------------------

//STRIP001 void OfaFilterOptions::SetLoadPPointBasicCode( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_PPOINT_CODE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsLoadPPointBasicCode() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_PPOINT_CODE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetLoadPPointBasicStorage( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_PPOINT_STORAGE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

/*N*/ BOOL OfaFilterOptions::IsLoadPPointBasicStorage() const
/*N*/ {
/*N*/ 	return pImp->IsFlag( FILTERCFG_PPOINT_STORAGE );
/*N*/ }

// -----------------------------------------------------------------------

//STRIP001 BOOL OfaFilterOptions::IsMathType2Math() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_MATH_LOAD );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetMathType2Math( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_MATH_LOAD, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsMath2MathType() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_MATH_SAVE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetMath2MathType( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_MATH_SAVE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }


// -----------------------------------------------------------------------
//STRIP001 BOOL OfaFilterOptions::IsWinWord2Writer() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_WRITER_LOAD );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetWinWord2Writer( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_WRITER_LOAD, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsWriter2WinWord() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_WRITER_SAVE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetWriter2WinWord( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_WRITER_SAVE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }


// -----------------------------------------------------------------------
//STRIP001 BOOL OfaFilterOptions::IsExcel2Calc() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_CALC_LOAD );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetExcel2Calc( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_CALC_LOAD, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsCalc2Excel() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_CALC_SAVE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetCalc2Excel( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_CALC_SAVE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }


// -----------------------------------------------------------------------
//STRIP001 BOOL OfaFilterOptions::IsPowerPoint2Impress() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_IMPRESS_LOAD );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetPowerPoint2Impress( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_IMPRESS_LOAD, bFlag );
//STRIP001 	SetModified();
//STRIP001 }

//STRIP001 BOOL OfaFilterOptions::IsImpress2PowerPoint() const
//STRIP001 {
//STRIP001 	return pImp->IsFlag( FILTERCFG_IMPRESS_SAVE );
//STRIP001 }

//STRIP001 void OfaFilterOptions::SetImpress2PowerPoint( BOOL bFlag )
//STRIP001 {
//STRIP001 	pImp->SetFlag( FILTERCFG_IMPRESS_SAVE, bFlag );
//STRIP001 	SetModified();
//STRIP001 }




}
