/*************************************************************************
 *
 *  $RCSfile: filtdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:59:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_FILTDLG_HXX
#define SC_FILTDLG_HXX

#ifndef _MOREBTN_HXX //autogen
#include <vcl/morebtn.hxx>
#endif
#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#ifndef SC_SCGLOB_HXX
#include "global.hxx" // -> ScQueryParam
#endif

#ifndef SC_ANYREFDG_HXX
#include "anyrefdg.hxx"
#endif
namespace binfilter {


//----------------------------------------------------------------------------

class ScFilterOptionsMgr;
class ScRangeData;
class ScViewData;
class ScDocument;
class ScQueryItem;
class TypedStrCollection;

//==================================================================
// Gemeinsame Resource-Objekte:

#define _COMMON_FILTER_RSCOBJS \
    FixedLine       aFlOptions; \
	CheckBox		aBtnCase; \
	CheckBox		aBtnRegExp; \
	CheckBox		aBtnHeader; \
	CheckBox		aBtnUnique; \
	CheckBox		aBtnCopyResult; \
	ListBox			aLbCopyArea; \
	ScRefEdit		aEdCopyArea; \
	ScRefButton		aRbCopyArea; \
	CheckBox		aBtnDestPers; \
	FixedText		aFtDbAreaLabel; \
	FixedInfo		aFtDbArea; \
	OKButton		aBtnOk; \
	CancelButton	aBtnCancel; \
	HelpButton		aBtnHelp; \
	MoreButton		aBtnMore; \
	const String	aStrUndefined; \
	const String	aStrNoName; \
	const String	aStrNone;


//STRIP001 #define _INIT_COMMON_FILTER_RSCOBJS \
//STRIP001 aFlOptions      ( this, ScResId( FL_OPTIONS ) ), \
//STRIP001 aBtnCase		( this, ScResId( BTN_CASE ) ), \
//STRIP001 aBtnRegExp		( this, ScResId( BTN_REGEXP ) ), \
//STRIP001 aBtnHeader		( this, ScResId( BTN_HEADER ) ), \
//STRIP001 aBtnUnique		( this, ScResId( BTN_UNIQUE ) ), \
//STRIP001 aBtnCopyResult	( this, ScResId( BTN_COPY_RESULT ) ), \
//STRIP001 aLbCopyArea		( this, ScResId( LB_COPY_AREA ) ), \
//STRIP001 aEdCopyArea		( this, ScResId( ED_COPY_AREA ) ), \
//STRIP001 aRbCopyArea		( this, ScResId( RB_COPY_AREA ), &aEdCopyArea ), \
//STRIP001 aBtnDestPers	( this, ScResId( BTN_DEST_PERS ) ), \
//STRIP001 aFtDbAreaLabel	( this, ScResId( FT_DBAREA_LABEL ) ), \
//STRIP001 aFtDbArea		( this, ScResId( FT_DBAREA ) ), \
//STRIP001 aBtnOk			( this, ScResId( BTN_OK ) ), \
//STRIP001 aBtnCancel		( this, ScResId( BTN_CANCEL ) ), \
//STRIP001 aBtnHelp		( this, ScResId( BTN_HELP ) ), \
//STRIP001 aBtnMore		( this, ScResId( BTN_MORE ) ), \
//STRIP001 aStrNoName		( ScGlobal::GetRscString(STR_DB_NONAME) ), \
//STRIP001 aStrNone		( ScResId( SCSTR_NONE ) ), \
//STRIP001 aStrUndefined	( ScResId( SCSTR_UNDEFINED ) ),


//============================================================================
//STRIP001 class ScFilterDlg : public ScAnyRefDlg
//STRIP001 {
//STRIP001 public:
//STRIP001 					ScFilterDlg( SfxBindings* pB, SfxChildWindow* pCW, Window* pParent,
//STRIP001 								 const SfxItemSet&	rArgSet );
//STRIP001 					~ScFilterDlg();
//STRIP001 
//STRIP001 	virtual void	SetReference( const ScRange& rRef, ScDocument* pDoc );
//STRIP001 
//STRIP001 	virtual BOOL	IsRefInputMode() const;
//STRIP001 	virtual void	SetActive();
//STRIP001 
//STRIP001 	virtual BOOL	Close();
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine       aFlCriteria;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbField1;
//STRIP001 	ListBox			aLbCond1;
//STRIP001 	ComboBox		aEdVal1;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbConnect1;
//STRIP001 	ListBox			aLbField2;
//STRIP001 	ListBox			aLbCond2;
//STRIP001 	ComboBox		aEdVal2;
//STRIP001 	//----------------------------
//STRIP001 	ListBox			aLbConnect2;
//STRIP001 	ListBox			aLbField3;
//STRIP001 	ListBox			aLbCond3;
//STRIP001 	ComboBox		aEdVal3;
//STRIP001 	//----------------------------
//STRIP001 	FixedText		aFtConnect;
//STRIP001 	FixedText		aFtField;
//STRIP001 	FixedText		aFtCond;
//STRIP001 	FixedText		aFtVal;
//STRIP001 
//STRIP001 	_COMMON_FILTER_RSCOBJS
//STRIP001 
//STRIP001 	const String	aStrEmpty;
//STRIP001 	const String	aStrNotEmpty;
//STRIP001 	const String	aStrRow;
//STRIP001 	const String	aStrColumn;
//STRIP001 
//STRIP001 	ScFilterOptionsMgr*	pOptionsMgr;
//STRIP001 
//STRIP001 	const USHORT		nWhichQuery;
//STRIP001 	const ScQueryParam	theQueryData;
//STRIP001 	ScQueryItem*		pOutItem;
//STRIP001 	ScViewData*			pViewData;
//STRIP001 	ScDocument*			pDoc;
//STRIP001 	USHORT				nSrcTab;
//STRIP001 
//STRIP001 	ComboBox*			aValueEdArr[3];
//STRIP001 	ListBox*			aFieldLbArr[3];
//STRIP001 	ListBox*			aCondLbArr[3];
//STRIP001 	USHORT				nFieldCount;
//STRIP001 	BOOL				bRefInputMode;
//STRIP001 
//STRIP001 	TypedStrCollection*	pEntryLists[MAXCOL+1];
//STRIP001 	USHORT				nHeaderPos[MAXCOL+1];
//STRIP001 
//STRIP001 	// Hack: RefInput-Kontrolle
//STRIP001 	Timer*	pTimer;
//STRIP001 
//STRIP001 #ifdef _FILTDLG_CXX
//STRIP001 private:
//STRIP001 	void			Init			( const SfxItemSet&	rArgSet );
//STRIP001 	void			FillFieldLists	();
//STRIP001 	void			FillAreaList	();
//STRIP001 	void			UpdateValueList	( USHORT nList );
//STRIP001 	void			UpdateHdrInValueList( USHORT nList );
//STRIP001 	void			ClearValueList	( USHORT nList );
//STRIP001 	USHORT			GetFieldSelPos	( USHORT nField );
//STRIP001 	ScQueryItem*	GetOutputItem	();
//STRIP001 
//STRIP001 	// Handler:
//STRIP001 	DECL_LINK( LbSelectHdl,	 ListBox* );
//STRIP001 	DECL_LINK( ValModifyHdl, ComboBox* );
//STRIP001 	DECL_LINK( CheckBoxHdl,	 CheckBox* );
//STRIP001 	DECL_LINK( EndDlgHdl,	 Button* );
//STRIP001 	DECL_LINK( MoreClickHdl, MoreButton* );
//STRIP001 
//STRIP001 	// Hack: RefInput-Kontrolle
//STRIP001 	DECL_LINK( TimeOutHdl,	 Timer* );
//STRIP001 #endif
//STRIP001 };


//============================================================================
//STRIP001 class ScSpecialFilterDlg : public ScAnyRefDlg
//STRIP001 {
//STRIP001 public:
//STRIP001 					ScSpecialFilterDlg( SfxBindings* pB, SfxChildWindow* pCW, Window* pParent,
//STRIP001 										const SfxItemSet&	rArgSet );
//STRIP001 					~ScSpecialFilterDlg();
//STRIP001 
//STRIP001 	virtual void	SetReference( const ScRange& rRef, ScDocument* pDoc );
//STRIP001 
//STRIP001 	virtual BOOL	IsRefInputMode() const;
//STRIP001 	virtual void	SetActive();
//STRIP001 
//STRIP001 	virtual BOOL	Close();
//STRIP001 
//STRIP001 private:
//STRIP001 	ListBox		aLbFilterArea;
//STRIP001 	FixedText	aFtFilterArea;
//STRIP001 	ScRefEdit	aEdFilterArea;
//STRIP001 	ScRefButton	aRbFilterArea;
//STRIP001 
//STRIP001 	_COMMON_FILTER_RSCOBJS
//STRIP001 
//STRIP001 	ScFilterOptionsMgr*	pOptionsMgr;
//STRIP001 
//STRIP001 	const USHORT		nWhichQuery;
//STRIP001 	const ScQueryParam	theQueryData;
//STRIP001 	ScQueryItem*		pOutItem;
//STRIP001 	ScViewData*			pViewData;
//STRIP001 	ScDocument*			pDoc;
//STRIP001 
//STRIP001 	ScRefEdit*			pRefInputEdit;
//STRIP001 	BOOL				bRefInputMode;
//STRIP001 
//STRIP001 	// Hack: RefInput-Kontrolle
//STRIP001 	Timer*	pTimer;
//STRIP001 
//STRIP001 #ifdef _SFILTDLG_CXX
//STRIP001 private:
//STRIP001 	void			Init( const SfxItemSet& rArgSet );
//STRIP001 	ScQueryItem*	GetOutputItem( const ScQueryParam& rParam,
//STRIP001 									const ScRange& rSource );
//STRIP001 
//STRIP001 	// Handler
//STRIP001 	DECL_LINK( FilterAreaSelHdl, ListBox* );
//STRIP001 	DECL_LINK( FilterAreaModHdl, ScRefEdit* );
//STRIP001 	DECL_LINK( EndDlgHdl,		 Button* );
//STRIP001 
//STRIP001 	// Hack: RefInput-Kontrolle
//STRIP001 	DECL_LINK( TimeOutHdl,		 Timer* );
//STRIP001 #endif
//STRIP001 };



} //namespace binfilter
#endif // SC_FILTDLG_HXX

