/*************************************************************************
 *
 *  $RCSfile: sfx2_accelinfo.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:24:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "app.hxx"
#include "accmgr.hxx"

// auto strip #ifndef _RTL_USTRING_HXX_
// auto strip #include <rtl/ustring.hxx>
// auto strip #endif

// auto strip #ifndef _SV_KEYCODE_HXX
// auto strip #include <vcl/keycod.hxx>
// auto strip #endif

#ifndef _SFXMSGPOOL_HXX
#include <msgpool.hxx>
#endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_URL_HPP_
// auto strip #include <com/sun/star/util/URL.hpp>
// auto strip #endif

#ifndef _SFX_SFXUNO_HXX
#include <bf_sfx2/sfxuno.hxx>
#endif

namespace binfilter {

/*N*/ ::rtl::OUString SAL_CALL GetCommandURLFromKeyCode( const KeyCode& aKeyCode )
/*N*/ {
/*N*/     SfxAcceleratorManager* pAccManager = SFX_APP()->GetGlobalAcceleratorManager();
/*N*/ 	if ( pAccManager )
/*N*/ 	{
/*N*/ 		USHORT nId = pAccManager->GetId( aKeyCode );
/*N*/ 		if ( nId > 0 )
/*N*/ 		{
/*N*/             const SfxSlot* pSlot = SFX_APP()->GetSlotPool().GetSlot( nId );
/*N*/ 
/*N*/             // create the dispatch name from the slot data
/*N*/             ::com::sun::star::util::URL aURL;
/*N*/             String aName( pSlot && pSlot->pUnoName ? String::CreateFromAscii(pSlot->GetUnoName()) : String() );
/*N*/             String aCmd;
/*N*/             if ( aName.Len() )
/*N*/             {
/*N*/                 aCmd = DEFINE_CONST_UNICODE(".uno:");
/*N*/                 aCmd += aName;
/*N*/             }
/*N*/             else
/*N*/             {
/*N*/                 aCmd = DEFINE_CONST_UNICODE("slot:");
/*N*/                 aCmd += String::CreateFromInt32( nId );
/*N*/             }
/*N*/ 
/*N*/ 			return aCmd;
/*N*/ 		}
/*N*/ 	}
/*N*/ 
/*N*/ 	return ::rtl::OUString();
/*N*/ }
}
