/*************************************************************************
 *
 *  $RCSfile: sw_wizfxdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:58:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include "swtypes.hxx"
#include "uitool.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizfxdlg.hxx"
namespace binfilter {




WizardFaxDialog::WizardFaxDialog(Window* pParent)
	: SwWizardDialog( pParent, SW_RES(DLG_WIZARD_FX), 8 ),

	a1_Text_Stil  (this,SW_RES(DLG_FX1_Text_Stil  )),
	a1_RBtn_Stil1 (this,SW_RES(DLG_FX1_RBtn_Stil1 )),
	a1_RBtn_Stil2 (this,SW_RES(DLG_FX1_RBtn_Stil2 )),
	a1_RBtn_Stil3 (this,SW_RES(DLG_FX1_RBtn_Stil3 )),
	a1_Text_FaxTit(this,SW_RES(DLG_FX1_Text_FaxTit)),
	a1_CLst_FaxTit(this,SW_RES(DLG_FX1_CLst_FaxTit)),
	a1_Text_Format(this,SW_RES(DLG_FX1_Text_Format)),
	a1_List_Format(this,SW_RES(DLG_FX1_List_Format)),

	aLogo(this),

	a3_PBtn_LoadAdr(this,SW_RES(DLG_FX3_Btn_LoadAdr)),
	a3_MEdt_AbsInp(this,SW_RES(DLG_FX3_MEdt_AbsInp)),
	a3_Text_Telfon(this,SW_RES(DLG_FX3_Text_Telfon)),
	a3_Edit_Telfon(this,SW_RES(DLG_FX3_Edit_Telfon)),
	a3_Text_Telfax(this,SW_RES(DLG_FX3_Text_Telfax)),
	a3_Edit_Telfax(this,SW_RES(DLG_FX3_Edit_Telfax)),
    a3_FL_AbsInp(this,SW_RES(DLG_FX3_FL_AbsInp)),
	a3_BBtn_AbsnOL(this,SW_RES(DLG_FX3_BBtn_AbsnOL)),
	a3_BBtn_AbsnOR(this,SW_RES(DLG_FX3_BBtn_AbsnOR)),
	a3_Text_AbsnWd(this,SW_RES(DLG_FX3_Text_AbsnWd)),
	a3_MFld_AbsnWd(this,SW_RES(DLG_FX3_MFld_AbsnWd)),
	a3_Text_AbsnHg(this,SW_RES(DLG_FX3_Text_AbsnHg)),
	a3_MFld_AbsnHg(this,SW_RES(DLG_FX3_MFld_AbsnHg)),
    a3_FL_AbsPos(this,SW_RES(DLG_FX3_FL_AbsPos)),

	aEmpf(this,TRUE,FALSE),

	a5_Text_Welche(this,SW_RES(DLG_FX5_Text_Welche)),
	a5_CBox_Datum (this,SW_RES(DLG_FX5_CBox_Datum )),
    a5_List_Datum (this,SW_RES(DLG_FX5_List_Datum ), NUMBERFORMAT_DATE, ULONG_MAX, FALSE),
	a5_CBox_Uhrzt (this,SW_RES(DLG_FX5_CBox_Uhrzt )),
    a5_List_Uhrzt (this,SW_RES(DLG_FX5_List_Uhrzt ), NUMBERFORMAT_TIME, ULONG_MAX, FALSE),
	a5_CBox_Betref(this,SW_RES(DLG_FX5_CBox_Betref)),
	a5_Edit_Betref(this,SW_RES(DLG_FX5_Edit_Betref)),
	a5_CBox_KopiAn(this,SW_RES(DLG_FX5_CBox_KopiAn)),
	a5_CBox_Elem1 (this,SW_RES(DLG_FX5_CBox_Elem1 )),
	a5_Edit_Elem1 (this,SW_RES(DLG_FX5_Edit_Elem1 )),
	a5_CBox_Elem2 (this,SW_RES(DLG_FX5_CBox_Elem2 )),
	a5_Edit_Elem2 (this,SW_RES(DLG_FX5_Edit_Elem2 )),
	a5_CBox_Elem3 (this,SW_RES(DLG_FX5_CBox_Elem3 )),
	a5_Edit_Elem3 (this,SW_RES(DLG_FX5_Edit_Elem3 )),
	a5_CBox_Elem4 (this,SW_RES(DLG_FX5_CBox_Elem4 )),
	a5_Edit_Elem4 (this,SW_RES(DLG_FX5_Edit_Elem4 )),

	aFusz(this,FALSE),
	aMarg(this),

	a8_BMap_Fahne (this,SW_RES(DLG_FX8_BMap_Fahne )),
	a8_Text_Final (this,SW_RES(DLG_FX8_Text_Final ))

{
	// set HC images
	a3_PBtn_LoadAdr.SetModeImage(SW_RES(DLG_FX3_Img_LoadAdr),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnOL.SetModeImage(SW_RES(DLG_FX3_Img_AbsnOL),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnOR.SetModeImage(SW_RES(DLG_FX3_Img_AbsnOR),BMP_COLOR_HIGHCONTRAST);

	FreeResource();

	FieldUnit eMetric = ::GetDfltMetric(FALSE);
	a3_MFld_AbsnWd.SetUnit(eMetric);
	a3_MFld_AbsnHg.SetUnit(eMetric);
}

WizardFaxDialog::~WizardFaxDialog()
{
}


}
